
/*
Edité avec le créateur de plugin MuseScore3
Michel Come (Novembre 2019)
Accordéon diatonique Sol/Do 21 touches sur deux rangées.
Conforme au plan de clavier de Bernard Loffet.

Version 2: Pour plusieur diatos
Version 3: Accepte les accidents d'armure
Version 4: Indication main gauche
Version 5: Recherche des accords préférenciels par mesure
 */

import QtQuick 2.0
import MuseScore 3.0


MuseScore   
{
version: "3.0"
description: "Tablature d'accordéon diatonique Sol/Do"
menuPath: 'Plugins.Tablature pour diato Sol/Do'

function priorite (Indice , Liste, Defaut)
{
// Pousser = true   Tirer = false
      switch (Liste[Indice - 1])
      {
      case "A": return false ; break ;
      case "C": return true  ; break ;
      case "D": return false ; break ;
      case "E": return true  ; break ;
      case "F":
            if (Indice > 0)
            {
            return !priorite(Indice-1 , Liste, Defaut);
            }
            else
            {
            return Defaut ;
            }
            break ;
      case "G":
            if (Indice > 0)
            {
            return !priorite(Indice-1 , Liste, Defaut);
            }
            else
            {
            return Defaut ;
            }
            break ;
      }
}
      onRun:         
      {    
      if (typeof curScore === 'undefined')Qt.quit();
      var Pous = 2.5;
      var Tire = 5.0;
      var Sens = 0;
      var Accord = "?" ;
      var Curseur = curScore.newCursor();
            for (var Instrument = 0; Instrument < curScore.nstaves; Instrument = Instrument + 2)
            {
            Curseur.staffIdx = Instrument ;
            Curseur.voice=0 ;
            Curseur.rewind(Element.SCORE_START);
            // indication des lignes pousser et tirer (P / T)
            var PT = newElement(Element.STAFF_TEXT);
            Curseur.add(PT) ;
            PT.fontSize = 12 ;
            PT.sizeSpatiumDependent = false;
            PT.text = "P\nT" ;
            PT.autoplace = false ;
            PT.placement = Placement.BELOW ;
            PT.offsetY = Pous ;
            PT.offsetX = - 7 ;
 // Recherche des accords
            var ListAc = [] ;            
                  // Pour chaque segment jusqu'à la fin
                  while (Curseur.segment) 
                  {  
                  var TickMax = Curseur.measure.lastSegment.tick ;
                  var Cdo = 0 ;
                  var Dre = 0 ;
                  var Emi = 0 ;
                  var Ffa = 0 ;
                  var Gsol = 0 ;
                  var Ala = 0 ;
                  var AcMax = 0 ;
                         // Pour toutes les notes de la mesure
                        while(Curseur.segment && Curseur.segment.tick < TickMax)
                        {
                        var Position = Curseur.tick;
                        var Pas = division ;
                        if (Curseur.measure.timesigActual.numerator == 6) { Pas = division * 1.5 } ;
                        if (Curseur.measure.timesigActual.numerator == 9) { Pas = division * 1.5 } ;
                        if (Curseur.measure.timesigActual.numerator == 12) { Pas = division * 1.5 } ;
                              if (Math.floor(Position / Pas) * Pas == Position)
                              {
                                    if (Curseur.element && Curseur.element.type === Element.CHORD)
                                    {
                                    // incrémenter la pertinence des accords concernés par chaque note
                                    var Midi = Curseur.element.notes[0].pitch;
                                          switch (Midi)
                                          {
                                          case 50: Dre ++ ; Gsol ++ ; break ;
                                          case 52: Cdo ++ ; Emi ++ ; Ala ++ ; break ;
                                          case 53: Dre ++ ; Ffa ++ ; break ;
                                          case 55: Cdo ++ ; Emi ++ ; Gsol ++ ; break ; 
                                          case 57: Dre ++ ; Ffa ++ ; Ala ++ ; break ;
                                          case 59: Emi ++ ; Gsol ++ ; break ;
                                          case 60: Cdo ++ ; Ffa ++ ; Ala ++ ; break ;
                                          case 62: Dre ++ ; Gsol ++ ; break ;
                                          case 64: Cdo ++ ; Emi ++ ; Ala ++ ; break ;
                                          case 65: Dre ++ ; Ffa ++ ; break ;
                                          case 67: Cdo ++ ; Emi ++ ; Gsol ++ ; break ;
                                          case 69: Dre ++ ; Ffa ++ ; Ala ++ ; break ;
                                          case 71: Emi ++ ; Gsol ++ ; break ;
                                          case 72: Cdo ++ ; Ffa ++ ; Ala ++ ; break ;
                                          case 74: Dre ++ ; Gsol ++ ; break ;
                                          case 76: Cdo ++ ; Emi ++ ; Ala ++ ; break ;
                                          case 77: Dre ++ ; Ffa ++ ; break ;;
                                          case 79: Cdo ++ ; Emi ++ ; Gsol ++ ; break ;
                                          case 81: Dre ++ ; Ffa ++ ; Ala ++ ; break ;
                                          case 83: Emi ++ ; Gsol ++ ; break ;
                                          case 84: Cdo ++ ; Ffa ++ ; Ala ++ ; break ;
                                          case 86: Dre ++ ; Gsol ++ ; break ;
                                          case 88: Cdo ++ ; Emi ++ ; Ala ++ ; break ;  
                                          }  // Fin de MIDI incrémente la pertinence                           
                                    }     // Fin de si le segment à du son
                              }     // Fin de si c'est un temps fort      
                        Curseur.next() ;
                        }     // Fin de la mesure
                        // Sélection de l'accord le plus pertinant pour cette mesure
                        if (Cdo > AcMax) { AcMax = Cdo ;  Accord = "C" }
                        if (Dre > AcMax) { AcMax = Dre ;  Accord = "D" }
                        if (Emi > AcMax) { AcMax = Emi ;  Accord = "E" }
                        if (Ffa > AcMax) { AcMax = Ffa ;  Accord = "F" }
                        if (Gsol > AcMax) { AcMax = Gsol ; Accord = "G" }
                        if (Ala > AcMax) { AcMax = Ala ;  Accord = "A" }

                        ListAc.push(Accord) ;
                  }     // Fin d'analyse de la partition
                  
  
                  Curseur.rewind(Element.SCORE_START);
                  var NuMesur = 0 ;
                  while (Curseur.segment) 
                  { 
                  NuMesur ++ ; 
                  // Priorité : Sens tiré/poussé
                        var Sens = Tire ;
                        if (priorite (NuMesur, ListAc, true)) {Sens = Pous}
                  // Paramètres de traitement des temps forts pour cette mesure
                  Pas = division ;
                  if (Curseur.measure.timesigActual.numerator == 6) { Pas = division * 1.5 } ;
                  if (Curseur.measure.timesigActual.numerator == 9) { Pas = division * 1.5 } ;
                  if (Curseur.measure.timesigActual.numerator == 12) { Pas = division * 1.5 } ;
                        
                        TickMax = Curseur.measure.lastSegment.tick ;
                        // Pour tous les segments de la mesure
                        while(Curseur.segment && Curseur.segment.tick < TickMax)
                        {
                              // seulement les éléments qui ont du son
                              if (Curseur.element && Curseur.element.type === Element.CHORD)
                              {
                              var Numero = newElement(Element.STAFF_TEXT);
                              //var Lettre = newElement(Element.STAFF_TEXT);
                              Midi = Curseur.element.notes[0].pitch; // Une seule note à la fois
                                    if (Sens == Pous)
                                    {
                                          switch (Midi)
                                          {
                                          case 50: Numero.text = "2"  ; break ;      // Ré
                                          case 52: Numero.text = "1'" ; break ;      // Mi
                                          case 53: Numero.text = "1'" ; Sens = Tire ; break ;      // Fa
                                          case 54: Numero.text = "2"  ; Sens = Tire ; break ;      // Fa#
                                          case 55: Numero.text = "2'" ; break ;      // Sol
                                          case 57: Numero.text = "3"  ; Sens = Tire ; break ;      // La
                                          case 59: Numero.text = "4"  ; break ;      // Si
                                          case 60: Numero.text = "3'" ; break ;      // Do
                                          case 62: Numero.text = "5"  ; break ;      // Ré
                                          case 64: Numero.text = "4'" ; break ;      // Mi
                                          case 65: Numero.text = "4'" ; Sens = Tire ; break ;      // Fa
                                          case 66: Numero.text = "6"  ; Sens = Tire ; break ;      // Fa#
                                          case 67: Numero.text = "6"  ; break ;      // Sol
                                          case 69: Numero.text = "7"  ; Sens = Tire ; break ;      // La
                                          case 71: Numero.text = "7"  ; break ;      // Si
                                          case 72: Numero.text = "6'" ; break ;      // Do
                                          case 74: Numero.text = "8"  ; break ;      // Ré
                                          case 76: Numero.text = "7'" ; break ;      // Mi
                                          case 77: Numero.text = "8'" ; Sens = Tire ; break ;      // Fa
                                          case 78: Numero.text = "10" ; Sens = Tire ; break ;      // Fa#
                                          case 79: Numero.text = "8'" ; break ;      // Sol
                                          case 81: Numero.text = "11" ; Sens = Tire ; break ;      // La
                                          case 83: Numero.text = "10" ; break ;      // Si
                                          case 84: Numero.text = "9'" ; break ;      // Do
                                          case 86: Numero.text = "11" ; break ;      // Ré
                                          case 88: Numero.text = "10'"; break ;      // Mi 
                                          }
                                    }
                                    else
                                    {
                                          switch (Midi)
                                          {
                                          case 50: Numero.text = "2"  ; Sens = Pous ; break ;      // Ré
                                          case 52: Numero.text = "1"  ; break ;      // Mi
                                          case 53: Numero.text = "1'" ; break ;      // Fa
                                          case 54: Numero.text = "2"  ; break ;      // Fa#
                                          case 55: Numero.text = "2'" ; Sens = Pous ; break ;      // Sol
                                          case 57: Numero.text = "3"  ; break ;      // La
                                          case 59: Numero.text = "2'" ; break ;      // Si
                                          case 60: Numero.text = "4"  ; break ;      // Do
                                          case 62: Numero.text = "3'" ; break ;      // Ré
                                          case 64: Numero.text = "5"  ; break ;      // Mi
                                          case 65: Numero.text = "4'" ; break ;      // Fa
                                          case 66: Numero.text = "6"  ; break ;      // Fa#
                                          case 67: Numero.text = "5'" ; Sens = Pous ; break ;      // Sol
                                          case 69: Numero.text = "7"  ; break ;      // La
                                          case 71: Numero.text = "6'" ; break ;      // Si
                                          case 72: Numero.text = "8"  ; break ;      // Do
                                          case 74: Numero.text = "7'" ; break ;      // Ré
                                          case 76: Numero.text = "9"  ; break ;      // Mi
                                          case 77: Numero.text = "8'" ; break ;      // Fa
                                          case 78: Numero.text = "10" ; break ;      // Fa#
                                          case 79: Numero.text = "9"  ; Sens = Pous ; break ;      // Sol
                                          case 81: Numero.text = "9'" ; break ;      // La
                                          case 83: Numero.text = "10'"; break ;      // Si
                                          case 84: Numero.text = "9'" ; Sens = Pous ; break ;      // Do
                                          case 86: Numero.text = "11" ; Sens = Pous ; break ;      // Ré
                                          case 88: Numero.text = "10'"; Sens = Pous ; break ;      // Mi 
                                          }
                                    }
                              Numero.autoplace = false ;
                              Curseur.add(Numero) ;
                              Numero.placement = Placement.BELOW ;
                              Numero.offsetY = Sens ;
                              
                                    // seulement les temps forts
                                    Position = Curseur.tick;
                                    if (Math.floor(Position / Pas) * Pas == Position)
                                    { 
                                    var Lettre = newElement(Element.STAFF_TEXT);
                                    if (ListAc[NuMesur - 1] == "A" && Sens == Pous) {ListAc[NuMesur - 1] = "E";}
                                    if (ListAc[NuMesur - 1] == "C" && Sens == Tire) {ListAc[NuMesur - 1] = "G";}
                                    if (ListAc[NuMesur - 1] == "D" && Sens == Pous) {ListAc[NuMesur - 1] = "G";}
                                    if (ListAc[NuMesur - 1] == "E" && Sens == Tire) {ListAc[NuMesur - 1] = "A";}
                                    Lettre.text = ListAc[NuMesur - 1];
                                    Lettre.autoplace = false ;
                                    Curseur.add(Lettre);
                                    Lettre.placement = Placement.BELOW ;
                                    Lettre.offsetY = 8 ;
                                    }     // fin des temps forts
                              }     // Fin de seulement les éléments qui ont du son
                        Curseur.next() ;
                        }     // fin de la mesure
                  }     // fin de la portée
            }     // fin de chaque instrument 
            Qt.quit();
      }     // fin de run
}     // fin de MuseScore